/****************************************************************************
** Form implementation generated from reading ui file 'GUI.ui'
**
** Created: nie gru 21 01:00:46 2003
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.1.1   edited Nov 21 17:40 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "gui.h"
#include "edytor.h"
#include "watek.h"

#include <qsplitter.h>
#include <qmultilineedit.h>
#include <qlayout.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qstatusbar.h>
#include <qtextbrowser.h>
#include <qfiledialog.h>

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

GUI::GUI( QWidget* parent, const char* name, WFlags fl )
    : QMainWindow( parent, name, fl )
{
    statusBar();
        
    setCentralWidget( new QWidget( this, "qt_central_widget" ) );
    GUILayout = new QGridLayout( centralWidget(), 1, 1, 11, 6, "GUILayout"); 

    splitter1 = new QSplitter( centralWidget(), "splitter1" );
    splitter1->setOrientation( QSplitter::Vertical );

    edytor1 = new QTextBrowser( splitter1 );

    edytor2 = new MojEdytor( splitter1, 0 );
    
    GUILayout->addWidget( splitter1, 0, 0 );

    zapiszAction = new QAction( this );
    zapiszAction->setText("Zapisz");
    zapiszBufAction = new QAction( this );
    zapiszBufAction->setText("Zapisz bufor");
    wczytajBufAction = new QAction( this );
    wczytajBufAction->setText("Wczytaj bufor");
    zakonczAction = new QAction( this );
    zakonczAction->setText(QString::fromLocal8Bit("Zakocz"));
    
    nowaAction = new QAction( this );
    nowaAction->setText("Nowa edycja");
    akceptujAction = new QAction( this );
    akceptujAction->setText("Akceptuj fragment");
    wyslijAction = new QAction( this );
    wyslijAction->setText(QString::fromLocal8Bit("Wylij na serwer"));

    menubar = new QMenuBar( this );

    plikMenu = new QPopupMenu( this );

    zapiszAction->addTo( plikMenu );
    zapiszBufAction->addTo( plikMenu );
    wczytajBufAction->addTo( plikMenu );
    plikMenu->insertSeparator();
    zakonczAction->addTo( plikMenu );
    
    menubar->insertItem( "Plik", plikMenu, 0 );
 
    edycjaMenu = new QPopupMenu( this );

    nowaAction->addTo( edycjaMenu );
    akceptujAction->addTo( edycjaMenu );
    edycjaMenu->insertSeparator();
    wyslijAction->addTo( edycjaMenu );
    menubar->insertItem( "Edycja", edycjaMenu, 1 );

    resize( QSize(600, 480).expandedTo(minimumSizeHint()) );

    connect( edytor2, SIGNAL( copyAvailable(bool) ), this, SLOT( zaznaczono(bool) ));
    connect( zapiszAction, SIGNAL( activated() ), this, SLOT( zapisz() ) );
    connect( zapiszBufAction, SIGNAL( activated() ), this, SLOT( zapiszBuf() ) );
    connect( wczytajBufAction, SIGNAL( activated() ), this, SLOT( wczytajBuf() ) );
    connect( zakonczAction, SIGNAL( activated() ), this, SLOT( zakoncz() ) );
    connect( nowaAction, SIGNAL( activated() ), this, SLOT( nowa() ) );
    connect( akceptujAction, SIGNAL( activated() ), this, SLOT( akceptuj() ) );
    connect( wyslijAction, SIGNAL( activated() ), this, SLOT( wyslij() ) );
    
    txt = 0;
    stan = NOWA;
}

GUI::~GUI() {
}

void GUI::setStatus(QString status) {
	statusBar()->message(status);
}

void GUI::zaznaczono(bool zaznaczono) {
	if (stan==NOWA && zaznaczono) {
		statusBar()->message(QString::fromLocal8Bit("Zaakceptuj wybr: edycja -> akceptuj"));
		akceptujAction->setEnabled(true);
	}
	else if (stan==NOWA) {
		statusBar()->message("Wybierz fragment do edycji");
		akceptujAction->setEnabled(false);
	}
}

void GUI::setWatek(WatekKlienta*watek) {
	this->watek = watek;
}

void GUI::appendPlain(char*txt) {
	wsk += strlen(txt);
	QString txt2 = convertFromPlainText(txt);
	richtxt.append(QString::fromLocal8Bit(txt2));
}

void GUI::appendRich(char*txt) {
	richtxt += txt;
}

// funkcja zaporzyczona ze zrodel qt i nieznacznie zmodyfikowana
// modyfikuje tekst tak, aby byl poprawnie wyswietlany w QTextBrowser
QString GUI::convertFromPlainText( const QString& plain)
{
    int col = 0;
    QString rich;
    for ( int i = 0; i < int(plain.length()); ++i ) {
	if ( plain[i] == '\n' ){
	    rich += "<br>";
	    col = 0;
	}
	else if ( plain[i] == '\t' ){
	    rich += 0x00a0U;
	    while ( col % 4 ) {
		rich += 0x00a0U;
		++col;
	    }
	}
	else if ( plain[i].isSpace() )
	    rich += 0x00a0U;
	else if ( plain[i] == '<' )
	    rich +="&lt;";
	else if ( plain[i] == '>' )
	    rich +="&gt;";
	else if ( plain[i] == '&' )
	    rich +="&amp;";
	else
	    rich += plain[i];
	++col;
    }
    return rich;
}


void GUI::setTxt(char*txt) {
	if (this->txt)
		free(this->txt);
	
	this->txt = txt;
	richtxt.truncate(0);
	wsk = 0;
}

void GUI::dodajRegion(unsigned long pocz, unsigned long kon) {
	if (pocz>wsk) {
		char* temp = (char*)malloc(pocz-wsk+1);
		temp[pocz-wsk]='\0';
		memcpy(temp, &(txt[wsk]), pocz-wsk);
		appendPlain(temp);
		free(temp);
	}
	
	char* temp = (char*)malloc(kon-pocz+2);
	temp[kon-pocz+1]='\0';
	memcpy(temp, &(txt[pocz]), kon-pocz+1);
	if (stan == EDYCJA && pocz==this->pocz && kon==this->kon)
		appendRich("<font color=\"blue\"><u>");
	else
		appendRich("<font color=\"red\"><u>");
	appendPlain(temp);
	appendRich("</u></font>");
	free(temp);
	
	wsk = kon + 1;
}

void GUI::finish() {
	if (txt[wsk]!='\0')
		appendPlain(&(txt[wsk]));
	
	edytor1->setText(richtxt);
	if (stan == NOWA)
		edytor2->setText(QString::fromLocal8Bit(txt));
}

void GUI::zakoncz() {
	exit(EXIT_SUCCESS);
}
void GUI::nowa() {
	if (stan==EDYCJA)
		watek->anulowanie();
	edytor2->setText(QString::fromLocal8Bit(txt));
	edytor2->setReadOnly(true);
	statusBar()->message("Wybierz fragment do edycji");
	zapiszBufAction->setEnabled(false);
	wczytajBufAction->setEnabled(false);
	wyslijAction->setEnabled(false);
	akceptujAction->setEnabled(false);
	stan=NOWA;
}

void GUI::akceptuj() {
	int a,b,c,d;
	int a1=0, c1=0;
	edytor2->getZaznaczenie(a, b, c, d);
	fflush(stdout);	
	int pocz=0, kon=0;
	
	while (a1!=a) {
		if (txt[pocz]=='\n')
			a1++;
		pocz++;
	}
	
	pocz += b;
	
	while (c1!=c) {
		if (txt[kon]=='\n')
			c1++;
		kon++;
	}	
	
	kon += d - 1;
	
	printf("Nowy fragment: %d %d %d %d %d %d\n", a,b,c,d,pocz,kon);
	
	this->pocz = pocz;
	this->kon = kon;
	stan = OCZEKIWANIE;
	watek->akceptacja(pocz, kon);
}

void GUI::edycja() {
	char* tmp = (char*)malloc(kon-pocz+2);
	tmp[kon-pocz+1]='\0';
	memcpy(tmp, &(txt[pocz]), kon-pocz+1);
	edytor2->setText(QString::fromLocal8Bit(tmp));
	free(tmp);
	edytor2->setReadOnly(false);
	zapiszBufAction->setEnabled(true);
	wczytajBufAction->setEnabled(true);
	wyslijAction->setEnabled(true);
	akceptujAction->setEnabled(false);

	stan=EDYCJA;
}

int GUI::getStan() {
	return stan;
}

void GUI::brakAkcpt() {
	setStatus("Serwer nie zaakceptowa"+QString(QChar(322))+" fragmentu, sprbuj ponownie");
	stan = NOWA;
}

void GUI::wyslij() {
	kon = pocz + getBufTxt().length() - 1;
	watek->wyslij();
	if (kon<pocz)
		nowa();
}

void GUI::setZmianaDl(long len) {
	kon += len;
	pocz += len;
}

QString GUI::getBufTxt() {
	return edytor2->text();
}

void GUI::zapisz() {
	QString f = QFileDialog::getSaveFileName();
    	if ( !f.isEmpty() )
		watek->zapisz(txt, f);
}

void GUI::zapiszBuf() {
	QString f = QFileDialog::getSaveFileName();
    	if ( !f.isEmpty() ) {
		watek->zapisz(QString::fromLocal8Bit(getBufTxt()), f);
	}
}

void GUI::wczytajBuf() {
	QString f = QFileDialog::getOpenFileName();
    	if ( !f.isEmpty() ) {
		int pd = open(f, O_RDONLY);
		if (pd == -1) {
			perror(0);
			return;
		}
		
		unsigned long pos;
		char buf[1025];
		
		edytor2->setText("");
		
		do {
      			memset(buf, '\0', 1025);
      			pos = read(pd, buf, 1024);
			edytor2->setText(edytor2->text()+QString::fromLocal8Bit(buf));	
		} while (pos);
		::close(pd);
	}
}

void GUI::koniec() {
	setStatus(QString::fromLocal8Bit("Serwer zamkn")+QString(QChar(322))+" po"+QString(QChar(322))+QString::fromLocal8Bit("czenie"));
	wyslijAction->setEnabled(false);
	akceptujAction->setEnabled(false);
	nowaAction->setEnabled(false);
}
